﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace WG_GetAbsoluteRowIndex
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            SetUpGridDataSource();
        }

        private void SetUpGridDataSource()
        {
            DataSet ds = new DataSet();
            DataTable t1 = ds.Tables.Add("table1");
            t1.Columns.Add("id", typeof(int)).AutoIncrement = true;
            t1.Columns.Add("Name", typeof(string));
            t1.Columns.Add("Quantity", typeof(int));
            t1.Columns.Add("Price", typeof(double));
            t1.Columns.Add("Date", typeof(DateTime));

            DataTable t2 = ds.Tables.Add("table2");
            t2.Columns.Add("id", typeof(int)).AutoIncrement = true;
            t2.Columns.Add("pid", typeof(int));
            t2.Columns.Add("Name", typeof(string));
            t2.Columns.Add("Address", typeof(string));
            t2.Columns.Add("Number", typeof(int));

            ds.Relations.Add(t1.Columns["id"], t2.Columns["pid"]);

            ds.Tables["table1"].Rows.Add(new object[] { null, "Beverage", 50, 10.2, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Appliances", 5, 90, new DateTime(2012, 05, 10) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "FastFood", 20, 32, new DateTime(2005, 10, 05) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Furniture", 12, 79, new DateTime(2009, 02, 28) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Meat", 40, 10.2, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Fruits", 25, 12, new DateTime(2012, 05, 10) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Vegetables", 30, 13, new DateTime(2005, 10, 05) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Cars", 13, 200, new DateTime(2009, 02, 28) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Tools", 60, 15.3, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Estate", 5, 3000, new DateTime(2012, 05, 10) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Motorcycles", 10, 320, new DateTime(2005, 10, 05) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Clothes", 40, 69, new DateTime(2009, 02, 28) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Shoes", 24, 40.6, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Games", 53, 50, new DateTime(2012, 05, 10) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Books", 42, 22, new DateTime(2005, 10, 05) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Movies", 38, 19, new DateTime(2009, 02, 28) });

            ds.Tables["table2"].Rows.Add(new object[] { null, 0, "Coca - Cola", " Somewhere", 2 });
            ds.Tables["table2"].Rows.Add(new object[] { null, 1, "Coca - Cola", " Somewhere", 2 });
            ds.Tables["table2"].Rows.Add(new object[] { null, 2, "Coca - Cola", " Somewhere", 2 });
            ds.Tables["table2"].Rows.Add(new object[] { null, 3, "Coca - Cola", " Somewhere", 2 });
            ds.Tables["table2"].Rows.Add(new object[] { null, 0, "Coca - Cola", " Somewhere", 2 });
            ds.Tables["table2"].Rows.Add(new object[] { null, 1, "Coca - Cola", " Somewhere", 2 });
            ds.Tables["table2"].Rows.Add(new object[] { null, 2, "Coca - Cola", " Somewhere", 2 });
            ds.Tables["table2"].Rows.Add(new object[] { null, 3, "Coca - Cola", " Somewhere", 2 });
            ds.Tables["table2"].Rows.Add(new object[] { null, 5, "Coca - Cola", " Somewhere", 2 });
            ds.Tables["table2"].Rows.Add(new object[] { null, 5, "Coca - Cola", " Somewhere", 2 });
            ds.Tables["table2"].Rows.Add(new object[] { null, 5, "Coca - Cola", " Somewhere", 2 });
            ds.Tables["table2"].Rows.Add(new object[] { null, 5, "Coca - Cola", " Somewhere", 2 });
            ds.Tables["table2"].Rows.Add(new object[] { null, 6, "Coca - Cola", " Somewhere", 2 });
            ds.Tables["table2"].Rows.Add(new object[] { null, 6, "Coca - Cola", " Somewhere", 2 });
            ds.Tables["table2"].Rows.Add(new object[] { null, 8, "Coca - Cola", " Somewhere", 2 });
            ds.Tables["table2"].Rows.Add(new object[] { null, 8, "Coca - Cola", " Somewhere", 2 });
            ds.Tables["table2"].Rows.Add(new object[] { null, 8, "Coca - Cola", " Somewhere", 2 });


            ultraGrid1.DataSource = ds;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Override.RowSelectors = Infragistics.Win.DefaultableBoolean.True;
            e.Layout.Rows.ExpandAll(true);
            e.Layout.Override.HeaderPlacement = HeaderPlacement.FixedOnTop;
        }

        private void ultraGrid1_AfterSelectChange(object sender, Infragistics.Win.UltraWinGrid.AfterSelectChangeEventArgs e)
        {
            var selectedRow = ultraGrid1.Selected.Rows.Count > 0 ? ultraGrid1.Selected.Rows[0] : null;

            if (selectedRow != null)
                this.ultraLabel1.Text = String.Format("Absolute index of the selected row: {0}.", this.GetAbsoluteRowIndex(selectedRow));
            else
                this.ultraLabel1.Text = "No selected row.";
                     
        }

        private int GetAbsoluteRowIndex(UltraGridRow row)
        {
            var rowVisibleIndex = row.VisibleIndex;

            var parentRow = row.ParentRow;

            while (parentRow != null)
            {
                rowVisibleIndex += GetAbsoluteRowIndex(parentRow) +1;
                parentRow = parentRow.ParentRow;
            }

            foreach (var siblingRow in row.ParentCollection)
            {
                if (siblingRow.VisibleIndex >= row.VisibleIndex)
                    continue;

                rowVisibleIndex += this.GetChildRowCount(siblingRow);
            }

            return rowVisibleIndex;
        }

        private int GetChildRowCount(UltraGridRow siblingRow)
        {
            var retVal = 0;
            if (siblingRow.ChildBands != null)
            {
                foreach (UltraGridChildBand band in siblingRow.ChildBands)
                {
                    foreach (UltraGridRow row in band.Rows)
                    {
                        retVal++;
                        retVal += this.GetChildRowCount(row);
                    }
                }
            }

            return retVal;
        }
    }
}
